/* This Class includes some calculations often used */

package engine;

import java.util.*;

public class Utils {
	
	
	/* Calculates how many months exists between date "start" and 
	 * date "end". Months are counted as changes in the "months" field. 
	 * 0 if in the same month.
	 */
	public static int calcMonths(Date start, Date end)
	{
		Calendar cs = Calendar.getInstance();
		Calendar ce = Calendar.getInstance();
		
		cs.setTime(start);
		ce.setTime(end);
		
		int ys = cs.get(Calendar.YEAR);
		int ye = ce.get(Calendar.YEAR);
		int ms = cs.get(Calendar.MONTH);
		int me = ce.get(Calendar.MONTH);
		
		int ret = 12 * (ye - ys);
		ret += me - ms;

		
		return ret;
	}

	/**
	 * Returns the variance of a group of values that were passed by parameters.
	 *  
	 * @param values
	 * The values from which the variance will be calculated.
	 * @return
	 */
	static public Double variance(Double[] values)
	{
		Double ret = 0.0;
		Double avg = 0.0;
		
		for (int i = 0; i < values.length; i++)
		{
			avg += values[i];
		}
		//This was not here in the demo version
		//Can't remember why - seems wrong to omit it.
		avg /= values.length; 
		
		for (int i = 0; i < values.length; i++)
		{
			ret += Math.pow((values[i] - avg), 2);
		}		
		
		if (ret < 0)
			System.err.println("negative variance!");
		
		return ret/values.length;
	}

	/** Calculates the average of an array of values.
	 * 
	 * @param values
	 * @return
	 */
	static public Double average(Double[] values)
	{
		Double ret = 0.0;
	
		for (int i = 0; i < values.length; i++)
		{
			ret += values[i];
		}
		
		return ret/values.length;		
	}

}
