package memetic;

import java.util.*;
import engine.*;
/*
 * GASolver Class
 * 
 * This is the main class to generate an optimal portfolio
 * using Memetic Algorithm. The memetic algorithm uses 
 * the GP base to evolve the portfolio structure, and local
 * search to decide the weights between portfolios.
 * 
 * This file is changed from the other solvers because it 
 * solves only one scenario. For solving multiple 
 * scenarios, 
 * 
 */


public class MemeSolver {

	MemePopulation pop;	

	Date startd; // The date for this scenario
	
	public MemeNode solution; // Current best solution
    double profit;	// Estimated return for the best solution
    double risk; // Risk for the best solution
    double sharpe; // Sharpe ratio for the best solution
    double distance; // distance measure for the best solution

    
    /*
     * The constructor leaves the Solver in a ready position
     * to be ran. After running the constructor, the user can 
     * RunMeme to run the entire evolution at one, or 
     * generation by generation.
     */
    public MemeSolver(MemeNode comp, Date startd)
    {

    	// If I need any parameters here, do this:
    	//Parameter param = Parameter.getInstance();
        //String paramval;
    	
    	
    	
    }
        

    /*
     * RunOneGen:
     * 
     * Runs one generation from the population, then 
     * updates the information for the best solution.
     * If done, returns 0. If not done yet, return 
     * the number of generations until done.
     */
    public int runOneGen()
    {
    	
    	return 0;
    }
    
    /*
     * RunAll:
     * 
     * Run the complete memetic algorithm evolution, 
     * then updates the information for the best 
     * solution. 
     * 
     * This can be ran even if a few "run one generation"
     * functions have been called already - it just
     * continues to run the remaining generations.
     */
    public void runAll()
    {
    	
    }
    
    /*
     * This method is a getter for the contents of the 
     * population. This should be called when the user wants 
     * to make evolutionary analysis or something like that.
     */
    public MemeNode[] getSolutions()
    {
    	
    	return null;
    }
    
}
