package testing;

import data.*;
import java.util.*;
import engine.*;
import ga.*;
import memetic.*;

public class Testmain {
	
	public static void main(String[] args) {

	System.err.println(":start: - " + args[0]);

		
	Parameter param = Parameter.getInstance(); 
	try {
		param.load(args[0]);		
	}
	catch (Exception e) {
		System.err.print(e.getMessage());
		System.exit(1);
	} 

	String parameter;
	Calendar c = Calendar.getInstance(); 	
	Market mkt = Market.getInstance();
	RNG die = RNG.getInstance();

	parameter = param.getParam("data directory");
	mkt.loadDir(parameter);	
	
	parameter = param.getParam("date");
	String[] date = parameter.split("-");
	c.set(Integer.parseInt(date[0]),
		  Integer.parseInt(date[1]),
		  Integer.parseInt(date[2]));

	parameter = param.getParam("Random Seed");
	die.setSeed(Integer.parseInt(parameter));
	
	double[] avg = new double[mkt.assets.size()];
	for (int i=0; i < avg.length; i++)
		avg[i] = 1.0 / avg.length;
	
		
	GAPopulation pop = new GAPopulation(null);
	pop.initPopulation(c.getTime());
	
	for (int i = 0; i < pop.ngens; i++)
	{
		pop.runGeneration();
		if (i%30 == 0)
			System.err.print(".");
	}
	System.err.println();
	
	pop.eval();
	Genome n = pop.individual.get(0);
	System.out.println("Return: " + n.Ereturn + " Sharpe: " +  n.fitness);
	
	System.err.println(":done:");
	}
	
	/** 
	 * Simply run the MemeNode Evolutionary System 
	 * on 1 scenario.
	 */
	static void runMemeNode(Date d)
	{
		MemePopulation pop = new MemePopulation(null);
		pop.initPopulation(d);
		
		for (int i = 0; i < pop.ngens; i++)
		{
			pop.runGeneration();
			pop.updateStatus();
			System.out.println(i + " " +
					pop.max_fitness[i] + " " +
					pop.avg_fitness[i] + " " +
					pop.terminals[i] + " " + 
					pop.bigterminals[i] + " " +
					pop.nodes[i] + " " +
					pop.introns[i]);
		}
	}
	
	static void runGene(Date d)
	{
		GAPopulation pop = new GAPopulation(null);
		pop.initPopulation(d);
		
		for (int i = 0; i < pop.ngens; i++)
		{
			pop.runGeneration();
			pop.updateStatus();
			System.out.println(i + " " +
					pop.max_fitness[i] + " " +
					pop.avg_fitness[i] + " " +
					pop.terminals[i] + " " + 
					pop.bigterminals[i]);
		}
	}

	
	
	
}


